<!DOCTYPE html>
<html lang="en" xmlns:v-on="http://www.w3.org/1999/xhtml">
<head>
    <meta charset="UTF-8">
    <title>Favorite Things</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <link rel="stylesheet" href="/static/css/index.css">
</head>
<body>

    <div id="root">
        <div class="container">
            <div class="row">
                <h1>Favorite Things
                    <button class="btn btn-primary" data-toggle="modal" data-target="#addFavoriteModal">Add Favorite</button>
                    <button class="btn btn-primary" v-on:click="viewLogs()">View Log</button>
                </h1>
                <table class="table">
                    <thead>
                        <tr>
                            <th scope="col">#</th>
                            <th scope="col">Title</th>
                            <th scope="col">Ranking</th>
                            <th scope="col">Category</th>
                            <th scope="col">Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr v-for="favorite in favorites">
                            <th scope="row" v-on:click="showFavorite(favorite.id)">${favorite.id}</th>
                            <td v-on:click="showFavorite(favorite.id)">${favorite.title}</td>
                            <td v-on:click="showFavorite(favorite.id)">${favorite.ranking}</td>
                            <td v-on:click="showFavorite(favorite.id)">${favorite.category.name}</td>
                            <td>
                                <button class="btn btn-info" v-on:click="editFavorite(favorite.id)">Edit</button>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
            <div class="row">
                <h1>Categories
                    <button class="btn btn-primary" data-toggle="modal" data-target="#addCategoryModal">Add Category</button>
                </h1>
            </div>
            <div class="row">
                <div class="list-group">
                    <h4 class="list-group-item" v-for="category in categories" v-on:click="showCategoryFavorites(category.id)">${category.name}</h4>
                </div>
            </div>
            <div class="modal fade" id="addFavoriteModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLongTitle" aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="exampleModalLongTitle">Add Favorite</h5>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <form v-on:submit.prevent="addFavorite()">
                            <div class="modal-body">
                                <div class="form-group">
                                    <label for="favorite_title">Title</label>
                                    <input
                                        type="text"
                                        class="form-control"
                                        id="favorite_title"
                                        placeholder="Enter Title"
                                        v-model="newFavorite.title"
                                        required="required" >
                                    <label for="favorite_description">Description</label>
                                    <textarea
                                        class="form-control"
                                        id="favorite_description"
                                        placeholder="Enter Optional Description"
                                        v-model="newFavorite.description"
                                        rows="3"></textarea>
                                    <label for="favorite_ranking">Ranking</label>
                                    <input
                                        type="number"
                                        class="form-control"
                                        id="favorite_ranking"
                                        min="1"
                                        value="1"
                                        v-model="newFavorite.ranking"
                                        required="required">
                                    <label for="favorite_category">Category</label>
                                    <select
                                        name="category"
                                        class="form-control"
                                        id="favorite_category"
                                        v-model="newFavorite.category"
                                        required="required" >
                                        <option v-for="category in categories" :value="category.name">${category.name}</option>
                                    </select>
                                </div>
                                <button type="submit" class="btn btn-primary">Save</button>
                            </div>
                        </form>
                    </div>
                </div>
                <div class="loading" v-if="loading===true">Loading&#8230;</div>
            </div>
            <div class="modal fade" id="editFavoriteModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLongTitle" aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="exampleModalLongTitle">Edit Favorite</h5>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <form v-on:submit.prevent="updateFavorite()">
                            <div class="modal-body">
                                <div class="form-group">
                                    <label for="favorite_title">Title</label>
                                    <input
                                        type="text"
                                        class="form-control"
                                        id="favorite_title"
                                        placeholder="Enter Title"
                                        v-model="currentFavorite.title"
                                        required="required" >
                                    <label for="favorite_description">Description</label>
                                    <textarea
                                        class="form-control"
                                        id="favorite_description"
                                        placeholder="Enter Optional Description"
                                        v-model="currentFavorite.description"
                                        rows="3"></textarea>
                                    <label for="favorite_ranking">Ranking</label>
                                    <input
                                        type="number"
                                        class="form-control"
                                        id="favorite_ranking"
                                        min="1"
                                        value="1"
                                        v-model="currentFavorite.ranking"
                                        required="required">
                                    <label for="favorite_category">Category</label>
                                    <select
                                        name="category"
                                        class="form-control"
                                        id="favorite_category"
                                        v-model="currentFavorite.category"
                                        required="required"
                                    >
                                        <option v-for="category in categories" :value="category.name">${category.name}</option>
                                    </select>
                                </div>
                                <button type="submit" class="btn btn-primary">Save</button>
                            </div>
                        </form>
                    </div>
                </div>
                <div class="loading" v-if="loading===true">Loading&#8230;</div>
            </div>
            <div class="modal fade" id="showFavoriteModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLongTitle" aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h3 class="modal-title" id="exampleModalLongTitle">Favorite</h3>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            <h5>${currentFavorite.title}</h5>
                            <p>${currentFavorite.description}</p><br>
                            <span>Ranking: ${currentFavorite.ranking}</span><br>
                            <span v-if="currentFavorite.category">Category: ${currentFavorite.category.name}</span><br>
                            <span>Created: ${currentFavorite.created}</span><br>
                            <span>Modified: ${currentFavorite.modified}</span><br>
                            <span>Metadata: ${currentFavorite.metadata}</span><br>
                            <button class="btn btn-info" v-on:click="editFavorite(currentFavorite.id)">Edit</button>
                        </div>
                    </div>
                </div>
                <div class="loading" v-if="loading===true">Loading&#8230;</div>
            </div>
            <div class="modal fade" id="showCategoryFavoritesModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLongTitle" aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h3 class="modal-title" id="exampleModalLongTitle">Favorites in Category ${currentCategory.name}</h3>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            <table class="table">
                                <thead>
                                    <tr>
                                        <th scope="col">#</th>
                                        <th scope="col">Title</th>
                                        <th scope="col">Ranking</th>
                                        <th scope="col">Category</th>
                                        <th scope="col">Action</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr v-for="favorite in categoryFavorites">
                                        <th scope="row" v-on:click="showFavorite(favorite.id)">${favorite.id}</th>
                                        <td v-on:click="showFavorite(favorite.id)">${favorite.title}</td>
                                        <td v-on:click="showFavorite(favorite.id)">${favorite.ranking}</td>
                                        <td v-on:click="showFavorite(favorite.id)">${favorite.category.name}</td>
                                        <td>
                                            <button class="btn btn-info" v-on:click="editFavorite(favorite.id)">Edit</button>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
                <div class="loading" v-if="loading===true">Loading&#8230;</div>
            </div>
            <div class="modal fade" id="addCategoryModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLongTitle" aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="exampleModalLongTitle">Add Category</h5>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <form v-on:submit.prevent="addCategory()">
                            <div class="modal-body">
                                <div class="form-group">
                                    <label for="category_name">Name</label>
                                    <input
                                        type="text"
                                        class="form-control"
                                        id="category_name"
                                        placeholder="Enter Name"
                                        v-model="newCategory.name"
                                        required="required" >
                                </div>
                                <button type="submit" class="btn btn-primary">Save</button>
                            </div>
                        </form>
                    </div>
                </div>
                <div class="loading" v-if="loading===true">Loading&#8230;</div>
            </div>
            <div class="modal fade" id="viewLogModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLongTitle" aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h3 class="modal-title" id="exampleModalLongTitle">Log</h3>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            <table class="table">
                                <thead>
                                    <tr>
                                        <th scope="col">#</th>
                                        <th scope="col">Timestamp</th>
                                        <th scope="col">Description</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr v-for="log in logs">
                                        <th scope="row" v-on:click="showFavorite(favorite.id)">${log.id}</th>
                                        <td v-on:click="showFavorite(favorite.id)">${log.datetime}</td>
                                        <td v-on:click="showFavorite(favorite.id)">${log.description}</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
                <div class="loading" v-if="loading===true">Loading&#8230;</div>
            </div>
        </div>
        <div class="loading" v-if="loading===true">Loading&#8230;</div>
    </div>


<script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
<script src="https://cdn.jsdelivr.net/npm/vue-resource@1.5.1"></script>

<script src="/static/javascript/index.js"></script>
</body>
</html>